function [R11 R12 R21 R22]=SuccessiveRmatix(r11,r12,r21,r22,Layers)


BinaryRep=BinaryRepresentation(Layers);
Digits=length(BinaryRep);
OneNumbers=0;
M_prime=(Digits-1);

I=eye(size(r11));
r_prime11=r11;
r_prime12=r12;
r_prime21=r21;
r_prime22=r22;

R_prime11=r_prime11;
R_prime12=r_prime12;
R_prime21=r_prime21;
R_prime22=r_prime22;

r_reserve11(:,:,1)=R_prime11;
r_reserve12(:,:,1)=R_prime12;
r_reserve21(:,:,1)=R_prime21;
r_reserve22(:,:,1)=R_prime22;

for l=1:M_prime
    Z=inv(r_prime11-r_prime22);
    Zr21=Z*r_prime21;
    Zr12=Z*r_prime12;
    R_prime11=r_prime11+r_prime12*Zr21;
    R_prime12=-r_prime12*Zr12;
    R_prime21=r_prime21*Zr21;
    R_prime22=r_prime22-r_prime21*Zr12;

    r_prime11=R_prime11;
    r_prime12=R_prime12;
    r_prime21=R_prime21;
    r_prime22=R_prime22;
    
    r_reserve11(:,:,l+1)=R_prime11;
    r_reserve12(:,:,l+1)=R_prime12;
    r_reserve21(:,:,l+1)=R_prime21;
    r_reserve22(:,:,l+1)=R_prime22;
end
for u=1:Digits
    if BinaryRep(u)==1
        OneNumbers=OneNumbers+1;
        r_zegond11(:,:,OneNumbers+1)=r_reserve11(:,:,1+Digits-u);
        r_zegond12(:,:,OneNumbers+1)=r_reserve12(:,:,1+Digits-u);
        r_zegond21(:,:,OneNumbers+1)=r_reserve21(:,:,1+Digits-u);
        r_zegond22(:,:,OneNumbers+1)=r_reserve22(:,:,1+Digits-u);
    end
end

RRR11(:,:,2)=r_zegond11(:,:,2);
RRR12(:,:,2)=r_zegond12(:,:,2);
RRR21(:,:,2)=r_zegond21(:,:,2);
RRR22(:,:,2)=r_zegond22(:,:,2);

for g=2:OneNumbers
    Z(:,:,g+1)=inv(r_zegond11(:,:,g+1)-RRR22(:,:,g));
    RRR11(:,:,g+1)=RRR11(:,:,g)+RRR12(:,:,g)*Z(:,:,g+1)*RRR21(:,:,g);
    RRR12(:,:,g+1)=-RRR12(:,:,g)*Z(:,:,g+1)*r_zegond12(:,:,g+1);
    RRR21(:,:,g+1)=r_zegond21(:,:,g+1)*Z(:,:,g+1)*RRR21(:,:,g);
    RRR22(:,:,g+1)=r_zegond22(:,:,g+1)-r_zegond21(:,:,g+1)*Z(:,:,g+1)*r_zegond12(:,:,g+1);
end
R11=RRR11(:,:,OneNumbers+1);
R12=RRR12(:,:,OneNumbers+1);
R21=RRR21(:,:,OneNumbers+1);
R22=RRR22(:,:,OneNumbers+1);
