clear
load PC1156r02
Nsamples = 1000;
wsamples = linspace(0.305,0.421,Nsamples);
Pout = wsamples;
phi = 0.45;
Lstub = 1;
for kk = 2 : Nsamples-1 
w = wsamples(kk);


[bikhod, Indw] = min(abs(wvec-w));
beta0 = Linearinterp(betaPCW(Indw-1),betaPCW(Indw),wvec(Indw-1),wvec(Indw),w);
betagap = Linearinterp(Blochr02(Indw-1),Blochr02(Indw),wvec(Indw-1),wvec(Indw),w);
beta01 = Linearinterp(Blochr01(Indw-1),Blochr01(Indw),wvec(Indw-1),wvec(Indw),w)*1.015;
Zr02kk = Linearinterp(Zr02(Indw-1),Zr02(Indw),wvec(Indw-1),wvec(Indw),w);
Zr01kk = Linearinterp(Zr01(Indw-1),Zr01(Indw),wvec(Indw-1),wvec(Indw),w);

lambda = 1/w;
k0 =2*pi/lambda;

Y2 = 1/Inputimpedance(1,beta0,phi/beta0,Zr02kk);
Y1 = 1/Inputimpedance(1,beta0,Lstub+phi/beta0,Zr02kk);

Ystub = Y1-Y2;
Zin = 1/(1+Ystub);

R = (Zin - 1)/(Zin + 1);
Pout(kk) = 1-abs(R)^2;
end
% figure
hold on;plot(wsamples,Pout,'k')
axis([0.305 0.42 0 1])
